<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for
 * OTA_AirSeatMapRQSeatMapRequestSeatDetailsResBookDesignation StructType
 * @package Dg
 * @subpackage Structs
 */
class DgOTA_AirSeatMapRQSeatMapRequestSeatDetailsResBookDesignation extends AbstractStructBase
{
    /**
     * The ResBookDesigCode
     * @var string
     */
    public $ResBookDesigCode;
    /**
     * Constructor method for
     * OTA_AirSeatMapRQSeatMapRequestSeatDetailsResBookDesignation
     * @uses DgOTA_AirSeatMapRQSeatMapRequestSeatDetailsResBookDesignation::setResBookDesigCode()
     * @param string $resBookDesigCode
     */
    public function __construct($resBookDesigCode = null)
    {
        $this
            ->setResBookDesigCode($resBookDesigCode);
    }
    /**
     * Get ResBookDesigCode value
     * @return string|null
     */
    public function getResBookDesigCode()
    {
        return $this->ResBookDesigCode;
    }
    /**
     * Set ResBookDesigCode value
     * @param string $resBookDesigCode
     * @return \dgsoft\StructType\DgOTA_AirSeatMapRQSeatMapRequestSeatDetailsResBookDesignation
     */
    public function setResBookDesigCode($resBookDesigCode = null)
    {
        // validation for constraint: string
        if (!is_null($resBookDesigCode) && !is_string($resBookDesigCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($resBookDesigCode)), __LINE__);
        }
        $this->ResBookDesigCode = $resBookDesigCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgOTA_AirSeatMapRQSeatMapRequestSeatDetailsResBookDesignation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
